abuild.in 44.5 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2
#!/bin/sh

3
# script to build apk packages (light version of makepkg)
Natanael Copa's avatar
Natanael Copa committed
4 5 6 7 8 9 10
# Copyright (c) 2008 Natanael Copa <natanael.copa@gmail.com>
#
# Distributed under GPL-2
#
# Depends on: busybox utilities, fakeroot, 
#

Natanael Copa's avatar
Natanael Copa committed
11 12
abuild_ver=@VERSION@
sysconfdir=@sysconfdir@
13
abuildrepo_base=@abuildrepo@
Natanael Copa's avatar
Natanael Copa committed
14
datadir=@datadir@
Natanael Copa's avatar
Natanael Copa committed
15

16
program=${0##*/}
17
abuild_path=$(readlink -f $0)
Natanael Copa's avatar
Natanael Copa committed
18 19

# defaults
20
BUILD_BASE="build-base"
21
FAKEROOT=${FAKEROOT:-"fakeroot"}
22

23 24
: ${SUDO_APK:=abuild-apk}
: ${APK:=apk}
25 26 27
: ${ADDUSER:=abuild-adduser}
: ${ADDGROUP:=abuild-addgroup}

28
apk_opt_wait="--wait 30"
29

Natanael Copa's avatar
Natanael Copa committed
30
# read config
Natanael Copa's avatar
Natanael Copa committed
31
ABUILD_CONF=${ABUILD_CONF:-"$sysconfdir/abuild.conf"}
Natanael Copa's avatar
Natanael Copa committed
32 33
[ -f "$ABUILD_CONF" ] && . "$ABUILD_CONF"

34
default_colors() {
Natanael Copa's avatar
Natanael Copa committed
35 36 37 38 39 40
	NORMAL="\033[1;0m"
	STRONG="\033[1;1m"
	RED="\033[1;31m"
	GREEN="\033[1;32m"
	YELLOW="\033[1;33m"
	BLUE="\033[1;34m"
41 42 43 44 45 46 47 48 49 50 51 52 53 54
}

monochrome() {
	NORMAL=""
	STRONG=""
	RED=""
	GREEN=""
	YELLOW=""
	BLUE=""
}

#colors
if [ -n "$USE_COLORS" ]; then
    default_colors
Natanael Copa's avatar
Natanael Copa committed
55 56 57 58 59
fi	
	

# functions
msg() {
60
	[ -n "$quiet" ] && return 0
Natanael Copa's avatar
Natanael Copa committed
61 62 63
	local prompt="$GREEN>>>${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
64 65 66 67 68 69 70
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

msg2() {
	[ -n "$quiet" ] && return 0
	#      ">>> %s"
	printf "    %s\n" "$1" >&2
Natanael Copa's avatar
Natanael Copa committed
71 72 73 74 75 76
}

warning() {
	local prompt="${YELLOW}>>> WARNING:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
77 78 79 80 81 82
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

warning2() {
	#      ">>> WARNING: 
	printf "             %s\n" "$1" >&2
Natanael Copa's avatar
Natanael Copa committed
83 84 85 86 87 88
}

error() {
	local prompt="${RED}>>> ERROR:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
89 90 91 92 93 94
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

error2() {
	#      ">>> ERROR: 
	printf "           %s\n" "$1" >&2
Natanael Copa's avatar
Natanael Copa committed
95
}
96

Linux User's avatar
Linux User committed
97
set_xterm_title() {
98
	if [ "$TERM" = xterm ] && [ -n "$USE_COLORS" ]; then
99
		 printf "\033]0;$1\007" >&2
Linux User's avatar
Linux User committed
100 101 102 103 104
	fi
} 

cleanup() {
	set_xterm_title ""
105
	if [ -z "$install_after" ] && [ -n "$uninstall_after" ]; then
106
		msg "Uninstalling dependencies..."
107
		$SUDO_APK del --quiet $apk_opt_wait $uninstall_after
108
	fi
109 110 111
	if [ -n "$CLEANUP_FILES" ]; then
		rm -f $CLEANUP_FILES
	fi
Linux User's avatar
Linux User committed
112 113
}

Natanael Copa's avatar
Natanael Copa committed
114
die() {
Linux User's avatar
Linux User committed
115
	error "$@"
Linux User's avatar
Linux User committed
116
	cleanup
Natanael Copa's avatar
Natanael Copa committed
117 118 119
	exit 1
}

120
# check if apkbuild is basicly sane
121
default_sanitycheck() {
122
	local i= j= suggestion=
123
	msg "Checking sanity of $APKBUILD..."
124 125 126
	[ -z "$pkgname" ] && die "Missing pkgname in APKBUILD"
	[ -z "${pkgname##* *}" ] && die "pkgname contains spaces"
	[ -z "$pkgver" ] && die "Missing pkgver in APKBUILD"
127
	if [ "$pkgver" != "volatile" ] && [ -z "$nodeps" ]; then
128
		$APK version --check -q "$pkgver" ||\
129 130
			die "$pkgver is not a valid version"
	fi
131
	[ -z "$pkgrel" ] && die "Missing pkgrel in APKBUILD"
132 133 134
	[ -z "$pkgdesc" ] && die "Missing pkgdesc in APKBUILD"
	[ -z "$url" ] && die "Missing url in APKBUILD"
	[ -z "$license" ] && die "Missing license in APKBULID"
135 136 137
	if [ $(echo "$pkgdesc" | wc -c) -gt 128 ]; then
		die "pkgdesc is too long"
	fi
138

139 140
	if [ -n "$replaces_priority" ] \
		&& ! echo $replaces_priority | egrep -q '^[0-9]+$'; then
141 142
		die "replaces_priority must be a number"
	fi
143 144 145 146 147 148 149
	# check so no package names starts with -
	for i in $pkgname $subpackages; do
		case $i in
		-*) die "${i%:*} is not a valid package name";;
		esac
	done

150 151 152 153 154 155 156 157 158 159
	# check if CARCH, CBUILD, CHOST and CTARGET is set
	if [ -z "$CARCH" ]; then
		case "$(uname -m)" in
		i[0-9]86) suggestion=" (Suggestion: CARCH=x86)";;
		x86_64) suggestion=" (Suggestion: CARCH=x86_64)";;
		esac
		die "Please set CARCH in /etc/abuild.conf$suggestion"
	fi
	[ -z "$CHOST" ] && die "Please set CHOST in /etc/abuild.conf"

Natanael Copa's avatar
Natanael Copa committed
160
	for i in $install; do
161
		local n=${i%.*}
162
		local suff=${i##*.}
163 164 165 166 167
		case "$suff" in
		pre-install|post-install|pre-upgrade|post-upgrade|pre-deinstall|post-deinstall);;
		*) die "$i: unknown install script suffix"
		esac
		if ! subpackages_has "$n" && [ "$n" != "$pkgname" ]; then
168
			die "$i: install script does not match pkgname or any subpackage"
169
		fi
170
		[ -e "$startdir/$i" ] || die "install script $i is missing"
171 172 173 174 175 176
		for j in chown chmod chgrp; do
			if grep -q $j "$startdir"/$i; then
				warning "$i: found $j"
				warning2 "Permissions should be fixed in APKBUILD package()"
			fi
		done
Natanael Copa's avatar
Natanael Copa committed
177 178
	done
	
179 180 181 182 183 184 185 186
	for i in $triggers; do
		local f=${i%=*}
		local p=${f%.trigger}
		[ "$f" = "$i" ] && die "$f: triggers must contain '='" 
		[ "$p" = "$f" ] && die "$f: triggers scripts must have .trigger suffix"
		if ! subpackages_has "$p" && [ "$p" != "$pkgname" ]; then
			die "$p: trigger script does not match pkgname or any subpackage"
		fi
Natanael Copa's avatar
Natanael Copa committed
187

188 189
		[ -e "$startdir"/$f ] || die "trigger script $f is missing"
	done
190 191
	if [ -n "$source" ]; then
		for i in $source; do
Natanael Copa's avatar
Natanael Copa committed
192 193 194 195
			if install_has "$i"; then
				warning "You should not have \$install in source"
				continue
			fi
196 197
			list_has ${i##*/} $md5sums $sha256sums $sha512sums \
				|| die "${i##*/} is missing in checksums"
198
			case "$i" in
199
				https://*) makedepends_has wget && warning "wget no longer need to be in makedepends when source has https://" ;;
200
			esac
201 202
		done
	fi
Natanael Copa's avatar
Natanael Copa committed
203

204 205 206 207 208 209 210 211
	# verify that things listed in checksum also is listed in source
	local algo=
	for algo in md5 sha256 sha512; do
		eval set -- \$${algo}sums
		while [ $# -gt 1 ]; do
			local file="$2"
			shift 2
			source_has $file || die "$file exists in ${algo}sums but is missing in source"
212
		done
213
	done
214

215 216 217
	# common spelling errors
	[ -n "$depend" ] && die "APKBUILD contains 'depend'. It should be depends"
	[ -n "$makedepend" ] && die "APKBUILD contains 'makedepend'. It should be makedepends"
Natanael Copa's avatar
Natanael Copa committed
218 219

	grep '^# Maintainer:' $APKBUILD >/dev/null || warning "No maintainer"
220 221

	makedepends_has 'g++' && warning "g++ should not be in makedepends"
222 223 224
	return 0
}

225 226 227 228
sanitycheck() {
	default_sanitycheck
}

229 230
sumcheck() {
	local algo="$1" sums="$2"
231
	local dummy f endreturnval originalparams origin file
232 233 234 235 236 237 238 239

	# get number of checksums
	set -- $sums
	local numsums=$(( $# / 2 ))

	set -- $source
	if [ $# -ne $numsums ]; then
		die "Number of ${algo}sums($numsums) does not correspond to number of sources($#)"
240
	fi
241
	fetch || return 1
242
	msg "Checking ${algo}sums..."
Natanael Copa's avatar
Natanael Copa committed
243
	cd "$srcdir" || return 1
244 245
	IFS=$'\n'
	endreturnval=0
246
	for src in $sums; do
247
		origin=$1; shift
248
		echo "$src" | ${algo}sum -c
249
		if [ $? -ne 0 ]; then
250
			endreturnval=1
251
			is_remote $origin || continue
252
			echo "Because the remote file above failed the ${algo}sum check it will be deleted."
253 254 255 256 257 258 259 260
			echo "Rebuilding will cause it to re-download which in some cases may fix the problem."
			file=`echo "$src" | sed 's/.*[ \t\n]\(.*\)/\1/'`
			echo "Deleting: $file"
			rm $file
		fi
	done
	unset IFS
	return $endreturnval
Natanael Copa's avatar
Natanael Copa committed
261 262
}

263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286
# for compatibility
md5check() {
	warning "'md5check' is deprecated. Use 'verify' instead"
	sumcheck md5 "$md5sums"
}

# verify checksums
verify() {
	local verified=false algo=
	for algo in md5 sha1 sha256 sha512; do
		local sums=
		eval sums=\"\$${algo}sums\"
		if [ -z "$sums" ] || [ -z "$source" ]; then
			continue
		fi
		sumcheck "$algo" "$sums" || return 1
		verified=true
	done
	if [ -n "$source" ] && ! $verified; then
		die "Use 'abuild checksum' to generate/update the checksum(s)"
	fi
	return 0
}

287 288
# verify upstream sources
sourcecheck() {
289 290 291 292 293 294 295 296 297 298
	local uri
	for uri in $source; do
		is_remote $uri || continue
		case "$uri" in
		saveas-*://*)
			uri=${uri#saveas-}
			uri=${uri%/*}
			;;
		esac
		wget -q -s "$uri" || return 1
299
	done
300
	return 0
301
}
302

303 304 305
# convert curl options to wget options and call wget instead of curl
wget_fallback() {
	local wget_opts= outfile= opt=
306
	while getopts "C:Lko:s" opt; do
307
		case $opt in
308
		'L') ;; # --location. wget does this by default
309
		'f') ;; # --fail. wget does this by default
310 311 312 313 314 315 316 317 318 319
		'C') wget_opts="$wget_opts -c";; # --continue-at
		's') wget_opts="$wget_opts -q";; # --silent
		'o') wget_opts="$wget_opts -O $OPTARG";; # --output
		'k') wget_opts="$wget_opts --no-check-certificate";; #gnu wget
		esac
	done
	shift $(( $OPTIND - 1 ))
	wget $wget_opts "$1"
}

Natanael Copa's avatar
Natanael Copa committed
320 321
uri_fetch() {
	local uri="$1"
322
	local d="${uri##*/}"	# $(basename $uri)
323
	local opts
324
	[ -n "$quiet" ] && opts="-s"
325 326

	local lockfile="$SRCDEST/$d".lock
327

328 329 330 331 332
	# fix saveas-*://* URIs
	case "$uri" in
		# remove 'saveas-' from beginning and
		# '/filename' from end of URI
		saveas-*://*) uri="${uri:7:$(expr ${#uri} - 7 - ${#d} - 1)}";;
333
	esac
334 335

	case "$uri" in
336
		https://*) opts="-k";;
337
	esac
338

Natanael Copa's avatar
Natanael Copa committed
339
	mkdir -p "$SRCDEST"
340 341 342

	CLEANUP_FILES="$CLEANUP_FILES $lockfile"
	(
343 344
	flock -n -x 9 || msg "Waiting for ${lockfile##*/}..."
	flock -x 9
345 346 347

	[ -f "$SRCDEST/$d" ] && exit 0 # use exit since its a subshell

348 349
	if [ -f "$SRCDEST/$d.part" ]; then
		msg "Partial download found. Trying to resume"
350
		opts="$opts -C -"
Natanael Copa's avatar
Natanael Copa committed
351
	fi
Linux User's avatar
Linux User committed
352
	msg "Fetching $uri"
353 354

	# fallback to wget if curl is missing. useful for bootstrapping
355
	local fetcher=
356 357
	if ! [ -x "$(which curl)" ]; then
		fetcher=wget_fallback
358 359
	else
		fetcher=curl
360
		opts="$opts -L -f -k"
361 362 363
	fi

	$fetcher $opts -o "$SRCDEST/$d.part" "$uri" \
364
		&& mv "$SRCDEST/$d.part" "$SRCDEST/$d"
365

366
	) 9>$lockfile
367 368 369 370

	local rc=$?
	rm -f "$lockfile"
	return $rc
Natanael Copa's avatar
Natanael Copa committed
371 372
}

373 374
is_remote() {
	case "$1" in
375
		http://*|ftp://*|https://*|saveas-*://*)
376 377 378 379 380
			return 0;;
	esac
	return 1
}

381 382 383 384 385
# try download from file from mirror first
uri_fetch_mirror() {
	local uri="$1"
	local d="${uri##*/}"	# $(basename $uri)
	if [ -n "$DISTFILES_MIRROR" ]; then
386 387 388 389 390
		if is_remote "$DISTFILES_MIRROR"; then
			uri_fetch "$DISTFILES_MIRROR"/$d && return 0
		else
			cp "$DISTFILES_MIRROR"/$d "$SRCDEST" && return 0
		fi
391 392 393 394
	fi
	uri_fetch "$uri"
}

395
default_fetch() {
Natanael Copa's avatar
Natanael Copa committed
396 397
	local s
	mkdir -p "$srcdir"
398 399
	for s in $source; do
		if is_remote "$s"; then
400
			uri_fetch_mirror "$s" || return 1
401 402 403 404
			ln -sf "$SRCDEST/${s##*/}" "$srcdir"/
		else		
			ln -sf "$startdir/$s" "$srcdir/"
		fi
Natanael Copa's avatar
Natanael Copa committed
405 406 407
	done
}

408 409 410 411
fetch() {
	default_fetch
}

Natanael Copa's avatar
Natanael Copa committed
412 413 414 415 416 417 418 419 420 421 422 423 424 425 426
# verify that all init.d scripts are openrc runscripts
initdcheck() {
	local i
	for i in $source; do
		case $i in
		*.initd)
			head -n 1 "$srcdir"/$i | grep -q '/sbin/runscript' \
				&& continue
			error "$i is not an openrc #!/sbin/runscript"
			return 1
			;;
		esac
	done			
}

Natanael Copa's avatar
Natanael Copa committed
427
# unpack the sources
428
default_unpack() {
Natanael Copa's avatar
Natanael Copa committed
429
	local u
430 431
	if [ -z "$force" ]; then
		md5check || return 1
Natanael Copa's avatar
Natanael Copa committed
432
		initdcheck || return 1
433
	fi
Natanael Copa's avatar
Natanael Copa committed
434 435 436 437
	mkdir -p "$srcdir"
	for u in $source; do
		local s="$SRCDEST/${u##*/}"	# $(basename $s)
		case "$s" in
438 439 440
			*.tar)
				msg "Unpacking $s..."
				tar -C "$srcdir" -xf "$s" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
441
			*.tar.gz|*.tgz)
442
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
443 444
				tar -C "$srcdir" -zxf "$s" || return 1;;
			*.tar.bz2)
445
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
446
				tar -C "$srcdir" -jxf "$s" || return 1;;
447 448 449 450
			*.tar.lzma)
				msg "Unpacking $s..."
				unlzma -c "$s" | tar -C "$srcdir" -x  \
					|| return 1;;
451 452 453
			*.tar.xz)
				msg "Unpacking $s..."
				unxz -c "$s" | tar -C "$srcdir" -x || return 1;;
Natanael Copa's avatar
Natanael Copa committed
454 455 456
			*.zip)
				msg "Unpacking $s..."
				unzip "$s" -d "$srcdir" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
457 458 459 460
		esac
	done
}

461 462 463 464
unpack() {
	default_unpack
}

Natanael Copa's avatar
Natanael Copa committed
465 466
# cleanup source and package dir
clean() {
467
	msg "Cleaning temporary build dirs..."
Natanael Copa's avatar
Natanael Copa committed
468
	rm -rf "$srcdir"
469
	rm -rf "$pkgbasedir"
Natanael Copa's avatar
Natanael Copa committed
470 471 472 473 474 475
}

# cleanup fetched sources
cleancache() {
	local s
	for s in $source; do
476 477 478 479
		if is_remote "$s"; then
			msg "Cleaning downloaded ${s##*/}..."
			rm -f "$SRCDEST/${s##*/}"
		fi
Natanael Copa's avatar
Natanael Copa committed
480 481 482
	done
}

483 484 485 486 487 488 489 490 491 492
listpkgnames() {
	local i
	for i in $pkgname $subpackages; do
		echo ${i%:*}
	done
	for i in $linguas; do
		echo $pkgname-lang-$i
	done
}

Natanael Copa's avatar
Natanael Copa committed
493 494
cleanpkg() {
	local i
495
	getpkgver || return 1
496
	msg "Cleaning built packages..."
497
	for i in $(listpkgnames); do
498 499
		local p="${i%:*}-$pkgver-r$pkgrel"
		rm -f "$PKGDEST/$p.apk" "$PKGDEST/$p.src.tar.gz" \
500
			"$abuildrepo"/$p.apk "$abuildrepo"/*/$p.apk
Natanael Copa's avatar
Natanael Copa committed
501
	done
502
	# remove given packages from index
Natanael Copa's avatar
Natanael Copa committed
503 504
}

505 506 507
# clean all packages except current
cleanoldpkg() {
	local i j
508
	getpkgver || return 1
509
	msg "Cleaning all packages except $pkgver-r$pkgrel..."
510
	for i in $(listpkgnames); do
511 512 513 514 515
		local pn=${i%:*}
		for j in "$PKGDEST"/$pn-[0-9]*.apk ; do
			[ "$j" = "$PKGDEST/$pn-$pkgver-r$pkgrel.apk" ] \
				&& continue
			rm -f "$j" "$abuildrepo"/*/${j##*/}
516 517 518 519
		done
	done
	return 0
}
520 521 522

mkusers() {
	local i
523 524 525 526 527 528
	for i in $pkggroups; do
		if ! getent group $i >/dev/null; then
			msg "Creating group $i"
			$ADDGROUP -S $i || return 1
		fi
	done
529 530
	for i in $pkgusers; do
		if ! getent passwd $i >/dev/null; then
531
			local gopt=
532
			msg "Creating user $i"
533 534 535
			if getent group $i >/dev/null; then
				gopt="-G $i"
			fi
536
			$ADDUSER -S -D -H $gopt $i || return 1
537 538 539 540 541
		fi
	done
}


Natanael Copa's avatar
Natanael Copa committed
542 543
runpart() {
	local part=$1
544
	[ -n "$DEBUG" ] && msg "$part"
Natanael Copa's avatar
Natanael Copa committed
545 546 547 548
	$part || die "$part failed"
}

# override those in your build script
549 550 551 552 553 554 555 556
getpkgver() {
	# this func is supposed to be overridden by volatile packages
	if [ "$pkgver" = "volatile" ]; then
		error "Please provide a getpkgver() function in your APKBUILD"
		return 1
	fi
}

Natanael Copa's avatar
Natanael Copa committed
557 558 559 560
prepare() {
	:
}

Natanael Copa's avatar
Natanael Copa committed
561
build() {
562
	:
Natanael Copa's avatar
Natanael Copa committed
563 564
}

565 566 567
# generate a simple tar.gz package of pkgdir
targz() {
	cd "$pkgdir" || return 1
Natanael Copa's avatar
Natanael Copa committed
568
	mkdir -p "$PKGDEST"
569 570 571
	tar -czf "$PKGDEST"/$pkgname-$pkgver-r$pkgrel.tar.gz *
}

572 573 574 575 576 577 578 579 580
get_split_func() {
	# get the 'func' from "sub-pkg:func"
	local func=${1##*:}

	# get 'func' from "sub-pkg-func" if there was no :func
	[ "$func" = "$1" ] && func=${func##*-}
	echo $func
}

581 582 583
postcheck() {
	local dir="$1" name="$2" i=
	msg "Running postcheck for $name"
584
	# checking for FHS compat
Natanael Copa's avatar
Natanael Copa committed
585 586 587 588 589 590 591 592
	if ! options_has "!fhs"; then
		for i in "$dir"/srv/* "$dir"/usr/local/* "$dir"/opt/*; do
			if [ -e "$i" ]; then
				error "Packages must not put anything under /srv, /usr/local or /opt"
				return 1
			fi
		done
	fi
593 594 595 596 597 598 599 600 601 602 603 604 605
	# look for *.la files
	i=$(find "$dir" -name '*.la' | sed "s|^$dir|\t|")
	if [ -n "$i" ] && ! options_has "libtool"; then
		error "Libtool archives (*.la) files found and \$options has no 'libtool' flag:"
		echo "$i"
		return 1
	fi
	# check directory permissions
	i=$(find "$dir" -type d -perm -777 | sed "s|^$dir|\t|")
	if [ -n "$i" ]; then
		warning "World writeable directories found:"
		echo "$i"
	fi
606 607 608 609 610 611 612 613 614
	# check so we dont have any suid root binaries that are not 
	i=$(find "$dir" -type f -perm +6000 \
		| xargs scanelf --nobanner --etype ET_EXEC \
		| sed "s|ET_EXEC $dir|\t|")
	if [ -n "$i" ]; then
		error "Found non-PIE files that has SUID:"
		echo "$i"
		return 1
	fi
615 616 617 618 619 620 621 622 623
	# test for textrels
	if ! options_has "textrels"; then
		local res="$(scanelf --recursive --textrel --quiet "$dir")"
		if [ -n "$res" ]; then
			error "Found textrels:"
			echo "$res"
			return 1
		fi
	fi
624 625 626
	return 0
}

627
prepare_subpackages() {
Natanael Copa's avatar
Natanael Copa committed
628 629
	local i
	cd "$startdir"
630
	for i in $subpackages; do
631 632
		local func=$(get_split_func $i)
		# call abuild recursively, setting subpkg{dir,name}
633
		msg "Running split function $func..."
634 635
		local dir="$pkgbasedir/${i%:*}" name="${i%:*}"
		subpkgdir="$dir" subpkgname="$name" \
636
			$0 $func prepare_package || return 1
637
		postcheck "$dir" "$name" || return 1
Natanael Copa's avatar
Natanael Copa committed
638
	done
639
	postcheck "$pkgdir" "$pkgname" || return 1
640 641
	# post check for /usr/share/locale
	if [ -d "$pkgdir"/usr/share/locale ]; then
642
		warning "Found /usr/share/locale"
643
		warning2 "Maybe add \$pkgname-lang to subpackages?"
644
	fi
Natanael Copa's avatar
Natanael Copa committed
645 646
}

647
default_lang() {
648
	pkgdesc="Languages for package $pkgname"
649 650 651 652 653 654 655 656 657 658 659 660 661
	install_if="$pkgname=$pkgver-r$pkgrel lang"
	arch="noarch"
	local dir
	for dir in ${langdir:-/usr/share/locale}; do
		mkdir -p "$subpkgdir"/${dir%/*}
		mv "$pkgdir"/"$dir" "$subpkgdir"/"$dir" || return 1
	done
}

lang() {
	default_lang
}

662
default_lang_subpkg() {
663 664 665 666
	if [ -z "$lang" ]; then
		error "lang is not set"
		return 1
	fi
667
	pkgdesc="$pkgname language pack for $lang"
668 669
	arch="noarch"
	install_if="$pkgname=$pkgver-r$pkgrel lang-$lang"
670 671 672 673 674
	local dir
	for dir in ${langdir:-/usr/share/locale}; do
		mkdir -p "$subpkgdir"/$dir
		mv "$pkgdir"/$dir/$lang* \
		"$subpkgdir"/$dir/ \
675
		|| return 1
676 677 678 679 680
	done
}

lang_subpkg() {
	default_lang_subpkg
681 682 683 684 685 686 687 688 689 690 691
}

prepare_language_packs() {
	for lang in $linguas; do
		lang="$lang" \
		subpkgname="$pkgname-lang-$lang" \
		subpkgdir="$pkgbasedir"/$subpkgname \
			$0 lang_subpkg prepare_package || return 1
	done
}

692 693 694 695 696 697 698 699 700 701 702 703
# echo '-dirty' if git is not clean
git_dirty() {
	if [ $(git status -s "$startdir" | wc -l) -ne 0 ]; then
		echo "-dirty"
	fi
}

# echo last commit hash id
git_last_commit() {
	git log --format=oneline -n 1 "$startdir" | awk '{print $1}'
}

704 705 706 707 708 709
get_maintainer() {
	if [ -z "$maintainer" ]; then
		maintainer=$(awk -F': ' '/\# *Maintainer/ {print $2}' "$APKBUILD")
	fi
}

710
prepare_metafiles() {
711
	getpkgver || return 1
712 713
	local name=${subpkgname:-$pkgname}
	[ -z "${name##* *}" ] && die "package name contains spaces"
714
	local dir=${subpkgdir:-$pkgdir}
715
	local pkg="$name-$pkgver-r$pkgrel.apk"
716
	local pkginfo="$controldir"/.PKGINFO
717
	local sub
Natanael Copa's avatar
Natanael Copa committed
718 719 720
	
	[ ! -d "$dir" ] && die "Missing $dir"
	cd "$dir"
721
	mkdir -p "$controldir"
Natanael Copa's avatar
Natanael Copa committed
722 723
	local builddate=$(date -u "+%s")
	local size=$(du -sk | awk '{print $1 * 1024}')
Natanael Copa's avatar
Natanael Copa committed
724
	local parch="$CARCH"
725 726 727 728 729

	# we need to wait with setting noarch til our build infra can handle it
#	if [ "$arch" = "noarch" ]; then
#		parch="noarch"
#	fi
Natanael Copa's avatar
Natanael Copa committed
730

731
	echo "# Generated by $(basename $0) $abuild_ver" >"$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
732
	if [ -n "$FAKEROOTKEY" ]; then
733
		echo "# using $($FAKEROOT -v)" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
734
	fi
735 736
	echo "# $(date -u)" >> "$pkginfo"
	cat >> "$pkginfo" <<EOF
737
pkgname = $name
738
pkgver = $pkgver-r$pkgrel
Natanael Copa's avatar
Natanael Copa committed
739 740 741 742 743
pkgdesc = $pkgdesc
url = $url
builddate = $builddate
packager = ${PACKAGER:-"Unknown"}
size = $size
Natanael Copa's avatar
Natanael Copa committed
744
arch = $parch
745
origin = $pkgname
Natanael Copa's avatar
Natanael Copa committed
746
EOF
747 748
	local i deps
	deps="$depends"
749
	if [ "$pkgname" != "busybox" ] && ! depends_has busbox; then
750 751
		for i in $install $triggers; do
			local s=${i%=*}
752
			[ "$name" != "${s%.*}" ] && continue
753
			if head -n 1 "$startdir/$s" | grep '^#!/bin/sh' >/dev/null ; then
754 755 756 757 758
				msg "Script found. busybox added as a dependency for $pkg"
				deps="$deps busybox"
				break
			fi
		done
759 760
	fi
	
761 762 763 764 765 766 767 768 769 770
	local last_commit="$(git_last_commit)$(git_dirty)"
	if [ -n "$last_commit" ]; then
		echo "commit = $last_commit" >> "$pkginfo"
	fi

	get_maintainer
	if [ -n "$maintainer" ]; then
		echo "maintainer = $maintainer" >> "$pkginfo"
	fi

771
	if [ -n "$replaces_priority" ]; then
772
		echo "replaces_priority = $replaces_priority" >> "$pkginfo"
773 774
	fi

Natanael Copa's avatar
Natanael Copa committed
775
	for i in $license; do
776
		echo "license = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
777 778
	done
	for i in $replaces; do
779
		echo "replaces = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
780
	done
781
	for i in $deps; do
782
		echo "depend = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
783 784
	done
	for i in $conflicts; do
785
		echo "conflict = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
786 787
	done
	for i in $provides; do
788
		echo "provides = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
789
	done
790 791 792 793 794 795
	for i in $triggers; do
		local f=${i%=*}
		local dirs=${i#*=}
		[ "${f%.trigger}" != "$name" ] && continue
		echo "triggers = ${dirs//:/ }" >> "$pkginfo"
	done
796 797 798
	if [ -n "$install_if" ]; then
		echo "install_if = $(echo $install_if)" >> "$pkginfo"
	fi
Natanael Copa's avatar
Natanael Copa committed
799 800

	local metafiles=".PKGINFO"
801 802 803
	for i in $install $triggers; do
		local f=${i%=*}
		local n=${f%.*}
804
		if [ "$n" != "$name" ]; then
805 806
			continue
		fi
807
		script=${f#$name}
808
		msg "Adding $script"
809
		cp "$startdir/$f" "$controldir/$script" || return 1
810
		chmod +x "$controldir/$script"
811 812
		metafiles="$metafiles $script"
	done
813
	echo $metafiles | tr ' ' '\n' > "$controldir"/.metafiles
814
}
815

816 817
prepare_tracedeps() {
	local dir=${subpkgdir:-$pkgdir}
818
	local etype= soname= file= sover=
819
	[ "$arch" = "noarch" ] && return 0
820
	options_has "!tracedeps" && return 0
821
	# lets tell all the places we should look for .so files - all rpaths
822 823
	scanelf --quiet --recursive --rpath "$dir" \
		| sed -e 's/[[:space:]].*//' -e 's/:/\n/' | sort -u \
824
		>"$controldir"/.rpaths
825 826 827 828 829 830 831
	if grep -q -x '/usr/lib' "$controldir"/.rpaths; then
		warning "Redundat /usr/lib in rpath found"
	fi
	if grep '^/home/' "$controldir"/.rpaths; then
		error "Has /home/... in rpath"
		return 1
	fi
Natanael Copa's avatar
Natanael Copa committed
832 833
}

834 835 836 837 838 839 840 841 842 843 844 845
# check if dir has arch specific binaries
dir_has_arch_binaries() {
	local dir="$1"
	# if scanelf returns something, then we have binaries
	[ -n "$(scanelf -R "$dir" | head -n 1)" ] && return 0

	# look for static *.a
	[ -n "$(find "$dir" -type f -name '*.a' | head -n 1)" ] && return 0

	return 1
}

846 847 848 849 850
# returns true if this is the -dev package
is_dev_pkg() {
	test "${subpkgname%-dev}" != "$subpkgname"
}

851 852 853 854 855 856 857
# check that noarch is set if needed
archcheck() {
	options_has "!archcheck" && return 0
	if dir_has_arch_binaries "${subpkgdir:-$pkgdir}"; then
		[ "$arch" != "noarch" ] && return 0
		error "Arch specific binaries found so arch must not be set to \"noarch\""
		return 1
858 859 860
	elif [ "$arch" != "noarch" ] && ! is_dev_pkg; then
		# we dont want -dev package go to noarch
		warning "No arch specific binaries found so arch should probably be set to \"noarch\""
861 862 863 864
	fi
	return 0
}

865
prepare_package() {
866
	msg "Preparing ${subpkgname:+sub}package ${subpkgname:-$pkgname}..."
867
	stripbin
868 869
	prepare_metafiles && prepare_tracedeps || return 1
	archcheck	
870 871 872 873 874 875 876 877
}

pkginfo_val() {
	local key="$1"
	local file="$2"
	awk -F ' = ' "\$1 == \"$key\" {print \$2}" "$file"
}

878 879 880 881 882 883 884 885 886 887 888 889 890 891 892 893 894 895 896 897 898 899 900
# find real path to so files
real_so_path() {
	local so="$1"
	shift
	while [ $# -gt 0 ]; do
		[ -e "$1"/$so ] && realpath "$1/$so" && return 0
		shift
	done
	error "$so: path not found"
	return 1
}

# search rpaths and /usr/lib /lib for given so files
find_so_files() {
	local rpaths=$(cat "$1")
	shift
	while [ $# -gt 0 ]; do
		real_so_path "$1" /usr/lib /lib $rpaths || return 1
		shift
	done
	return 0
}

901 902 903 904
subpkg_provides() {
	grep -q -w "^$1" "$pkgbasedir"/.control.*/.provides-so 2>/dev/null
}

905 906 907
trace_apk_deps() {
	local name="$1"
	local dir="$2"
908
	local i= found= autodeps= deppkgs= missing=
909
	msg "Tracing dependencies..."
910 911 912
	# add pkgconfig if usr/lib/pkgconfig is found
	if [ -d "$pkgbasedir"/$name/usr/lib/pkgconfig ] \
			&& ! grep -q '^depend = pkgconfig' "$dir"/.PKGINFO; then
913
		msg "  added pkgconfig (found /usr/lib/pkgconfig)"
914 915 916 917
		autodeps="$autodeps pkgconfig"
	fi

	# special case for libpthread: we need depend on libgcc
918
	if [ -f "$dir"/.needs-so ] && grep -q -w '^libpthread.so.*' "$dir"/.needs-so \
919 920
			&& ! grep -q -w "^depend = libgcc" "$dir"/.PKGINFO; then
		autodeps="$autodeps libgcc"
921
		msg "  added libgcc (due to libpthread)"
922
	fi
923
	[ -f "$dir"/.needs-so ] && for i in $(cat "$dir"/.needs-so); do
924 925 926 927 928
		# first check if its provided by same apkbuild
		grep -q -w "^$i" "$dir"/.provides-so 2>/dev/null && continue

		if subpkg_provides "$i" || $APK info -q -e "so:$i"; then
			autodeps="$autodeps so:$i"
929
		else
930
			missing="$missing $i"
931
		fi
932 933 934
	done

	# find all packages that holds the so files
935
	if [ -f "$dir"/.rpaths ]; then
936 937
		local so_files=$(find_so_files "$dir"/.rpaths $missing) \
			|| return 1
938 939 940
		deppkgs=$($APK info -q -W $so_files) || return 1
	fi

941
	for found in $deppkgs; do
942
		if grep -w "^depend = ${found}$" "$dir"/.PKGINFO >/dev/null ; then
943 944 945
			warning "You can remove '$found' from depends"
			continue
		fi
946
		autodeps="$autodeps $found"
947
	done
948

949
	echo "# automatically detected:" >> "$dir"/.PKGINFO
950
	if [ -f "$dir"/.provides-so ]; then
951
		sed 's/^\(.*\) \([0-9].*\)/provides = so:\1=\2/' "$dir"/.provides-so \
952
			>> "$dir"/.PKGINFO
953 954
	fi
	[ -z "$autodeps" ] && return 0
955
	for i in $autodeps; do
956 957
		echo "depend = $i"
	done | sort -u >> "$dir"/.PKGINFO
958 959
	# display all depends
	sed -n '/^depend =/s/depend = /\t/p' "$dir"/.PKGINFO >&2
960 961
}

962
find_scanelf_paths() {
963
	local datadir="$1"
Natanael Copa's avatar
Natanael Copa committed
964
	local paths="$datadir/lib:$datadir/usr/lib" i= rpaths=
965
	if [ -n "$ldpath" ]; then
966
		paths="$paths:$(echo "$ldpath" | sed "s|\(^\|:\)|\1$datadir|g")"
967 968
	fi
	# search in all rpaths
Natanael Copa's avatar
Natanael Copa committed
969 970
	for rpaths in "$pkgbasedir"/.control.*/.rpaths; do
		[ -f "$rpaths" ] || continue
971
		while read i; do
972 973 974 975
			local dir="${datadir}${i}"
			IFS=:
			if [ -d "$dir" ] && ! list_has "$dir" $paths; then
				paths="$paths:${dir}"
976
			fi
977
			unset IFS
Natanael Copa's avatar
Natanael Copa committed
978
		done < "$rpaths"
979 980 981 982 983 984
	done
	echo "$paths"
}

scan_shared_objects() {
	local name="$1" controldir="$2" datadir="$3"
985
	local opt=
986 987 988

	# allow spaces in paths
	IFS=:
989
	set -- $(find_scanelf_paths "$datadir")
990 991
	unset IFS

992 993 994
	if options_has "ldpath-recursive"; then
		opt="--recursive"
	fi
995 996
	msg "Scanning shared objects"
	# lets tell all the .so files this package provides in .provides-so
997
	scanelf --nobanner --soname $opt "$@" | while read etype soname file; do
998 999
		# if soname field is missing, soname will be the filepath
		sover=0
1000 1001
		if [ -z "$file" ]; then
			file="$soname"
1002
			soname=${soname##*/}
1003 1004 1005 1006 1007 1008 1009 1010 1011 1012 1013 1014 1015 1016
		fi

		# we only want shared libs
		case $soname in
		*.so|*.so.[0-9]*);;
		*) continue;;
		esac

		case "$file" in
		*.so.[0-9]*) sover=${file##*.so.};;
		*.so)
			# filter out sonames with version when file does not
			# have version
			case "$soname" in
1017 1018 1019 1020
			*.so.[0-9]*)
				if options_has "sover-namecheck"; then
					continue
				fi
1021 1022 1023
			esac
			;;
		esac
Natanael Copa's avatar
Natanael Copa committed
1024
		list_has "$soname" $somask && continue
1025
		echo "$soname $sover"
1026 1027 1028 1029 1030 1031 1032 1033 1034 1035
	# use awk to filter out dupes that has sover = 0
	done | awk '{ if (so[$1] == 0) so[$1] = $2; }
		END { for (i in so) print(i " " so[i]); }' \
		| sort -u > "$controldir"/.provides-so

	# verify that we dont have any duplicates
	local dupes="$(cut -d' ' -f1 "$controldir"/.provides-so | uniq -d)"
	if [ -n "$dupes" ]; then
		die  "provides multiple versions of same shared object: $dupes"
	fi
1036 1037 1038 1039 1040

	# now find the so dependencies
	scanelf --nobanner --recursive --needed "$datadir"  | tr ' ' ':' \
		| awk -F ":" '$1 == "ET_DYN" || $1 == "ET_EXEC" {print $2}'  \
		| sed 's:,:\n:g' | sort -u \
Natanael Copa's avatar
Natanael Copa committed
1041
	| while read soname; do
1042
		# only add files that are not self provided
Natanael Copa's avatar
Natanael Copa committed
1043 1044 1045
		grep -q -w "^$soname" "$controldir"/.provides-so \
			|| list_has "$soname" $somask \
			|| echo $soname
1046 1047 1048
	done > "$controldir"/.needs-so
}

1049 1050 1051 1052 1053 1054 1055 1056
# read size in bytes from stdin and show as human readable
human_size() {
	awk '{  split("B KB MB GB TB PB", type)
		for(i=5; y < 1; i--)
			y = $1 / (2**(10*i))
		printf("%.1f %s\n", y, type[i+2]) }'
}

1057
create_apks() {
1058
	local file= dir= name= ver= apk= datadir= size=
1059
	getpkgver || return 1
Natanael Copa's avatar
Natanael Copa committed
1060
	mkdir -p "$PKGDEST"
1061 1062 1063 1064 1065 1066 1067 1068 1069
	if [ "$arch" != "noarch" ] && ! options_has "!tracedeps"; then
		for file in "$pkgbasedir"/.control.*/.PKGINFO; do
			dir="${file%/.PKGINFO}"
			name="$(pkginfo_val pkgname $file)"
			datadir="$pkgbasedir"/$name
			subpkgname=$name
			scan_shared_objects "$name" "$dir" "$datadir"
		done
	fi
1070
	for file in "$pkgbasedir"/.control.*/.PKGINFO; do
1071 1072 1073
		dir="${file%/.PKGINFO}"
		name=$(pkginfo_val pkgname $file)
		ver=$(pkginfo_val pkgver $file)
1074
		size=$(pkginfo_val size $file | human_size)
1075 1076 1077
		apk=$name-$ver.apk
		datadir="$pkgbasedir"/$name
		subpkgname=$name
1078 1079

		trace_apk_deps "$name" "$dir" || return 1
1080
		msg "Package size: ${size}"
1081
		msg "Compressing data..."
1082
		(
1083 1084
		cd "$datadir"
		# data.tar.gz
1085 1086 1087 1088 1089 1090
		set -- *
		if [ "$1" = '*' ]; then
			touch .dummy
			set -- .dummy
		fi
		tar -c "$@" | abuild-tar --hash | gzip -9 >"$dir"/data.tar.gz
1091

1092
		msg "Create checksum..."
1093 1094 1095 1096 1097
		# append the hash for data.tar.gz
		local sha256=$(sha256sum "$dir"/data.tar.gz | cut -f1 -d' ')
		echo "datahash = $sha256" >> "$dir"/.PKGINFO

		# control.tar.gz
1098
		cd "$dir"
1099 1100
		tar -c $(cat "$dir"/.metafiles) | abuild-tar --cut \
			| gzip -9 > control.tar.gz
1101
		abuild-sign -q control.tar.gz || exit 1
Natanael Copa's avatar
Natanael Copa committed
1102

1103
		msg "Create $apk"
1104 1105
		# create the final apk
		cat control.tar.gz data.tar.gz > "$PKGDEST"/$apk
1106
		)
1107
	done
1108
	subpkgname=
1109 1110
}

1111
clean_abuildrepo() {
1112
	local apk
1113 1114 1115
	cd "$abuildrepo" || return 1
	
	# remove compat symlink
1116
	for d in "$abuildrepo/$CARCH"; do
1117 1118
		[ -L "$d" ] && rm "$d"
	done
1119

1120 1121
	# remove broken links from abuildrepo
	for apk in *.apk */*.apk; do
1122 1123 1124 1125
		if [ -L "$apk" ] && [ ! -f "$apk" ]; then
			rm -f "$apk"
		fi
	done
1126
}
1127

1128
mklinks_abuildrepo() {
1129 1130
	local apk
	mkdir -p "$abuildrepo"/$CARCH
1131
	cd "$abuildrepo" || return 1
1132
	# create links for this package
1133
	for apk in $(listpkg); do
1134
		[ -f "$PKGDEST"/$apk ] || continue
1135
		ln -sf "$PKGDEST"/$apk "$abuildrepo"/$CARCH/$apk
1136
	done
1137 1138 1139 1140 1141 1142 1143 1144 1145 1146 1147 1148 1149 1150
}

update_abuildrepo() {
	local d apk
	if ! apk_up2date || [ -n "$force" ]; then
		sanitycheck && builddeps && clean && fetch && unpack \
			&& prepare && mkusers && rootpkg || return 1
	fi

	clean_abuildrepo
	mklinks_abuildrepo

	cd "$abuildrepo"
	local index=$CARCH/APKINDEX.tar.gz
1151

1152
	msg "Updating the cached abuild repository index..."
1153 1154
	local sign=".SIGN.RSA.${SIGN_PUBLIC_KEY##*/}"
	local oldindex=
1155 1156
	if [ -f "$index" ]; then
		oldindex="--index $index"